---
title: Bluetooth.requestDevice()
slug: Web/API/Bluetooth/requestDevice
tags:
  - API
  - Bluetooth
  - Method
  - Reference
  - Web Bluetooth API
  - requestDevice
---
<p>{{APIRef("Bluetooth API")}} {{securecontext_header}}{{SeeCompatTable}}</p>

<p>The <strong><code>Bluetooth.requestDevice()</code></strong> method of the {{domxref("Bluetooth")}} interface returns a {{jsxref("Promise")}} to a {{domxref("BluetoothDevice")}} object with the specified options. If there is no chooser UI, this method returns the first device matching the criteria.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Bluetooth.requestDevice([options])
  .then(function(bluetoothDevice) { ... })</pre>

<h3 id="Returns">Returns</h3>

<p>A {{jsxref("Promise")}} to a {{domxref("BluetoothDevice")}} object.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>options {{optional_inline}}</dt>
 <dd>An object that sets options for the device request. The available options are:
 <ul>
  <li><code>filters[]</code>: An array of <code>BluetoothScanFilters</code>. This filter consists of an array of  <code>BluetoothServiceUUID</code>s, a <code>name</code> parameter, and a <code>namePrefix</code> parameter.</li>
  <li><code>optionalServices[]</code>: An array of <code>BluetoothServiceUUID</code>s.</li>
  <li><code>acceptAllDevices</code>: A {{domxref("Boolean")}} indicating that the requesting script can accept all Bluetooth devices. The default is <code>false</code>.</li>
 </ul>
 </dd>
</dl>

<h2 id="Exceptions">Exceptions</h2>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>The provided <code>options</code> do not makes sense. For example, <code>options.filters</code> is present and <code>options.acceptAllDevices</code> is <code>true</code>, or if <code>options.filters</code> is not present and <code>options.acceptAllDevices</code> is <code>false</code>. Or <code>options.filters</code> is <code>[]</code>.</dd>
 <dt><code>NotFoundError</code></dt>
 <dd>There is no Bluetooth device that matches the specified options.</dd>
 <dt><code>SecurityError</code></dt>
 <dd>This operation is not permitted in this context due to security concerns. For example, it is called from insecure origin.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">// Discovery options match any devices advertising:
// . The standard heart rate service.
// . Both 16-bit service IDs 0x1802 and 0x1803.
// . A proprietary 128-bit UUID service c48e6067-5295-48d3-8d5c-0395f61792b1.
// . Devices with name "ExampleName".
// . Devices with name starting with "Prefix".
//
// And enables access to the battery service if devices
// include it, even if devices do not advertise that service.
let options = {
  filters: [
    {services: ['heart_rate']},
    {services: [0x1802, 0x1803]},
    {services: ['c48e6067-5295-48d3-8d5c-0395f61792b1']},
    {name: 'ExampleName'},
    {namePrefix: 'Prefix'}
  ],
  optionalServices: ['battery_service']
}

navigator.bluetooth.requestDevice(options).then(function(device) {
  console.log('Name: ' + device.name);
  // Do something with the device.
})
.catch(function(error) {
  console.log("Something went wrong. " + error);
});
</pre>

<p><a href="https://webbluetoothcg.github.io/web-bluetooth/#example-filter-by-services">Detailed examples</a> are in the specification.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Bluetooth', '#dom-bluetooth-requestdevice', 'requestDevice()')}}</td>
   <td>{{Spec2('Web Bluetooth')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Bluetooth.requestDevice")}}</p>
</div>
